## kmail 24.12.3

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)
set(PIM_VERSION "6.3.3")

project(kmail VERSION ${PIM_VERSION})

include(CheckIncludeFiles)


set(KF_MIN_VERSION "6.6.0")
set(QT_REQUIRED_VERSION "6.7.0")
set(CMAKE_CXX_STANDARD 20)
find_package(ECM ${KF_MIN_VERSION} CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(ECMInstallIcons)
include(ECMSetupVersion)
include(ECMAddTests)

include(GenerateExportHeader)
include(ECMGenerateHeaders)

include(FeatureSummary)
include(KDEGitCommitHooks)
include(KDEClangFormat)
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h *.c)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
include(CheckFunctionExists)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMAddAppIcon)
include(ECMQtDeclareLoggingCategory)
include(ECMDeprecationSettings)
include(ECMFeatureSummary)

# Do NOT add quote
set(KDEPIM_DEV_VERSION )
set(RELEASE_SERVICE_VERSION "24.12.3")

# Update it for each release
set(KMAIL_RELEASE_VERSION_DATE "25.03.03") # yy.MM.dd

# add an extra space
if(DEFINED KDEPIM_DEV_VERSION)
    set(KDEPIM_DEV_VERSION " ${KDEPIM_DEV_VERSION}")
endif()

set(KDEPIM_VERSION "${PIM_VERSION}${KDEPIM_DEV_VERSION} (${RELEASE_SERVICE_VERSION})")


set(AKONADI_MIMELIB_VERSION "6.3.3")
set(AKONADI_CONTACT_VERSION "6.3.3")
set(CALENDARUTILS_LIB_VERSION "6.3.3")
set(IDENTITYMANAGEMENT_LIB_VERSION "6.3.3")
set(KLDAP_LIB_VERSION "6.3.3")
set(KMAILTRANSPORT_LIB_VERSION "6.3.3")
set(KONTACTINTERFACE_LIB_VERSION "6.3.3")
set(KMIME_LIB_VERSION "6.3.3")
set(KPIMTEXTEDIT_LIB_VERSION "6.3.3")
set(AKONADI_VERSION "6.3.3")
set(KTNEF_LIB_VERSION "6.3.3")
set(GPG_ERROR_REQUIRED_VERSION "1.36")

set(KDEPIM_LIB_VERSION "${PIM_VERSION}")
set(KDEPIM_LIB_SOVERSION "6")

set(KTEXTADDONS_MIN_VERSION "1.5.4")
option(KDEPIM_ENTERPRISE_BUILD "Enable features specific to the enterprise branch, which are normally disabled. Also, it disables many components not needed for Kontact such as the Kolab client." FALSE)

find_package(Qt6 ${QT_REQUIRED_VERSION} CONFIG REQUIRED DBus Network Test Widgets WebEngineWidgets)
set(LIBGRAVATAR_VERSION "6.3.3")
set(MAILCOMMON_LIB_VERSION "6.3.3")
set(MESSAGELIB_LIB_VERSION "6.3.3")
set(LIBKLEO_LIB_VERSION "6.3.3")
set(PIMCOMMON_LIB_VERSION "6.3.3")
set(LIBKDEPIM_LIB_VERSION "6.3.3")
set(LIBKSIEVE_LIB_VERSION "6.3.3")
set(AKONADI_SEARCH_VERSION "6.3.3")
set(QT6KEYCHAIN_LIB_VERSION "0.14.2")

find_package(KPim6WebEngineViewer ${MESSAGELIB_LIB_VERSION} CONFIG REQUIRED)

option(FORCE_DISABLE_AKONADI_SEARCH "Disable features and API that require akonadi-search, e.g. because xapian isn't available" OFF)
if(UNIX)
    if(NOT FORCE_DISABLE_AKONADI_SEARCH)
        find_package(KPim6AkonadiSearch ${AKONADI_SEARCH_VERSION} CONFIG REQUIRED)
        set_package_properties(KPim6AkonadiSearch PROPERTIES DESCRIPTION "The Akonadi Search libraries" URL "https://invent.kde.org/pim/akonadi-search" TYPE REQUIRED PURPOSE "Provides search capabilities in KMail and Akonadi")
    endif()
else()
    if(NOT FORCE_DISABLE_AKONADI_SEARCH)
        find_package(KPim6AkonadiSearch ${AKONADI_SEARCH_VERSION} CONFIG)
        set_package_properties(KPim6AkonadiSearch PROPERTIES DESCRIPTION "The Akonadi Search libraries" URL "https://invent.kde.org/pim/akonadi-search" TYPE OPTIONAL PURPOSE "Provides search capabilities in KMail and Akonadi")
    endif()
endif()

if(NOT KPim6AkonadiSearch_FOUND)
    set(KMAIL_FORCE_DISABLE_AKONADI_SEARCH TRUE)
endif()

set(GPGMEPP_LIB_VERSION "1.23.2")
find_package(Gpgmepp ${GPGMEPP_LIB_VERSION} CONFIG REQUIRED)

# Find KF6 package
find_package(KF6Bookmarks ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6Config ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6Crash ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6DBusAddons ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6DocTools ${KF_MIN_VERSION})
set_package_properties(KF6DocTools PROPERTIES DESCRIPTION
    "Tools to generate documentation"
    TYPE OPTIONAL
)
find_package(KF6GuiAddons ${KF_MIN_VERSION} REQUIRED)
find_package(KF6I18n ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6ItemViews ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6JobWidgets ${KF_MIN_VERSION} REQUIRED)
find_package(KF6KIO ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6KCMUtils ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6Notifications ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6NotifyConfig ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6Parts ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6Service ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6Sonnet ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6WidgetsAddons ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6WindowSystem ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6XmlGui ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6IconThemes ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6Contacts ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6CalendarCore ${KF_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6StatusNotifierItem ${KF_MIN_VERSION} CONFIG REQUIRED)

find_package(KPim6Akonadi ${AKONADI_VERSION} CONFIG REQUIRED)
find_package(KPim6AkonadiContactWidgets ${AKONADI_CONTACT_VERSION} CONFIG REQUIRED)
find_package(KPim6AkonadiMime ${AKONADI_MIMELIB_VERSION} CONFIG REQUIRED)
find_package(KPim6CalendarUtils ${CALENDARUTILS_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6IdentityManagementCore ${IDENTITYMANAGEMENT_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6LdapWidgets ${KLDAP_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6MailTransport ${KMAILTRANSPORT_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6TextEdit ${KPIMTEXTEDIT_LIB_VERSION} CONFIG REQUIRED)

find_package(KPim6KontactInterface ${KONTACTINTERFACE_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6Mime ${KMIME_LIB_VERSION} CONFIG REQUIRED)

find_package(KPim6Gravatar ${LIBGRAVATAR_VERSION} CONFIG REQUIRED)
find_package(KPim6Libkdepim ${LIBKDEPIM_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6Libkleo ${LIBKLEO_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6KSieveUi ${LIBKSIEVE_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6MailCommon ${MAILCOMMON_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6MessageCore ${MESSAGELIB_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6MessageComposer ${MESSAGELIB_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6MessageList ${MESSAGELIB_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6MessageViewer ${MESSAGELIB_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6PimCommonAkonadi ${PIMCOMMON_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6TemplateParser ${MESSAGELIB_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6Tnef ${KTNEF_LIB_VERSION} CONFIG REQUIRED)
find_package(KPim6MailTransportDBusService CONFIG REQUIRED)
find_package(KPim6PimCommonActivities ${PIMCOMMON_LIB_VERSION} CONFIG)

set(CMAKE_MODULE_PATH ${LIBKLEO_MODULE_PATH} ${CMAKE_MODULE_PATH})
find_package(LibGpgError ${GPG_ERROR_REQUIRED_VERSION} REQUIRED)

find_package(KF6TextEditTextToSpeech ${KTEXTADDONS_MIN_VERSION} CONFIG)
set_package_properties(KF6TextEditTextToSpeech PROPERTIES DESCRIPTION
    "Add support for text to speech"
    TYPE OPTIONAL
)
if(TARGET KF6::TextEditTextToSpeech)
    add_definitions(-DHAVE_TEXT_TO_SPEECH_SUPPORT)
endif()
find_package(KF6TextAutoCorrectionWidgets ${KTEXTADDONS_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6TextUtils ${KTEXTADDONS_MIN_VERSION} CONFIG REQUIRED)
find_package(KF6TextCustomEditor ${KTEXTADDONS_MIN_VERSION} CONFIG REQUIRED)
find_package(Qt6Keychain ${QT6KEYCHAIN_LIB_VERSION} CONFIG)
set_package_properties(Qt6Keychain PROPERTIES
    DESCRIPTION "Provides support for secure credentials storage"
    URL "https://github.com/frankosterfeld/qtkeychain"
    TYPE REQUIRED)

configure_file(config-enterprise.h.in ${CMAKE_CURRENT_BINARY_DIR}/config-enterprise.h)

include_directories(${kmail_SOURCE_DIR} ${kmail_BINARY_DIR})
configure_file(kmail-version.h.in ${CMAKE_CURRENT_BINARY_DIR}/kmail-version.h @ONLY)
if(BUILD_TESTING)
    add_definitions(-DBUILD_TESTING)
endif()
add_definitions(-DQT_NO_CONTEXTLESS_CONNECT)
ecm_set_disabled_deprecation_versions(QT 6.8.0
    KF 6.8.0
)
find_package(KF6UserFeedback ${KF_MIN_VERSION} CONFIG)
set_package_properties(KF6UserFeedback PROPERTIES DESCRIPTION "User Feedback lib" TYPE OPTIONAL PURPOSE "Allow to send Telemetry Information (optional).")

option(USE_UNITY_CMAKE_SUPPORT "Use UNITY cmake support (speedup compile time)" OFF)

set(COMPILE_WITH_UNITY_CMAKE_SUPPORT OFF)
if(USE_UNITY_CMAKE_SUPPORT)
    set(COMPILE_WITH_UNITY_CMAKE_SUPPORT ON)
endif()


option(USE_PRECOMPILED_HEADERS "Use precompiled headers" OFF) # Set to OFF when using clazy and such
set(COMPILE_WITH_CMAKE_PCH_SUPPORT OFF)
macro(pim_target_precompile_headers)
    if(USE_PRECOMPILED_HEADERS)
        set(COMPILE_WITH_CMAKE_PCH_SUPPORT ON)
        if(COMPILE_WITH_CMAKE_PCH_SUPPORT)
            target_precompile_headers(${ARGV})
        endif()
    endif()
endmacro()

if(TARGET KPim6::PimCommonActivities)
    option(OPTION_USE_PLASMA_ACTIVITIES "Activate plasma activities (experimental)" OFF)
    if(OPTION_USE_PLASMA_ACTIVITIES)
        if(NOT WIN32 AND NOT APPLE)
            set(OPTION_USE_PLASMA_ACTIVITIES true)
        else()
            set(OPTION_USE_PLASMA_ACTIVITIES false) 
        endif()
    endif()
    if(OPTION_USE_PLASMA_ACTIVITIES)
        if(NOT WIN32 AND NOT APPLE)
            find_package(PlasmaActivities "6.1.0")
            set_package_properties(PlasmaActivities PROPERTIES DESCRIPTION
                "Allow to compile with plasma activities"
                TYPE OPTIONAL
            )
        endif()

        if(TARGET Plasma::Activities)
            set(KMAIL_HAVE_ACTIVITY_SUPPORT TRUE)
        endif()
    endif()
endif()

configure_file(config-kmail.h.in ${CMAKE_CURRENT_BINARY_DIR}/config-kmail.h)

add_subdirectory(src)
add_subdirectory(agents)
add_subdirectory(ktnef)
add_subdirectory(kmail-refresh-settings)
ecm_qt_install_logging_categories(
    EXPORT KMAIL
    FILE kmail.categories
    DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
)

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)
ki18n_install(po)
if(KF6DocTools_FOUND)
    kdoctools_install(po)
    add_subdirectory(doc)
endif()
ecm_feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== agents/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
add_subdirectory(sendlateragent)
add_subdirectory(archivemailagent)
add_subdirectory(mailfilteragent)
add_subdirectory(followupreminderagent)
add_subdirectory(unifiedmailboxagent)
add_subdirectory(mailmergeagent)

=== kmail-refresh-settings/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2019-2024 Laurent Montel <montel.org>
# SPDX-License-Identifier: BSD-3-Clause
add_executable(kmail-refresh-settings)
target_sources(kmail-refresh-settings PRIVATE
    main.cpp
    refreshsettingsassistant.cpp
    refreshsettringsfinishpage.cpp
    refreshsettingscleanuppage.cpp
    refreshsettingsfirstpage.cpp
    refreshsettingsassistant.h
    refreshsettringsfinishpage.h
    refreshsettingscleanuppage.h
    refreshsettingsfirstpage.h
)

ecm_qt_declare_logging_category(kmail-refresh-settings HEADER kmail-refresh-settings_debug.h IDENTIFIER KMAIL_REFRESH_SETTINGS_LOG CATEGORY_NAME org.kde.pim.kmail_refresh_settings
        DESCRIPTION "kmail-refresh-settings"
        EXPORT KMAIL
)


if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(kmail-refresh-settings PROPERTIES UNITY_BUILD ON)
endif()
target_link_libraries(kmail-refresh-settings KF6::I18n KPim6::AkonadiWidgets KF6::DBusAddons KF6::Crash KF6::XmlGui)


install(TARGETS kmail-refresh-settings  ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(PROGRAMS org.kde.kmail-refresh-settings.desktop DESTINATION ${KDE_INSTALL_APPDIR})

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
add_definitions(-DTRANSLATION_DOMAIN=\"kmail\")

qt_generate_dbus_interface(kmkernel.h org.kde.kmail.kmail.xml OPTIONS -a)
qt_generate_dbus_interface(editor/kmcomposerwin.h org.kde.kmail.mailcomposer.xml OPTIONS -a)

add_custom_target(kmail_xml ALL
    DEPENDS ${kmail_BINARY_DIR}/src/org.kde.kmail.kmail.xml
    DEPENDS ${kmail_BINARY_DIR}/src/org.kde.kmail.mailcomposer.xml
    COMMENT "Helper target for XML stuff. The Kontact plugin, KOrganizer and others depend on it."
)

if(TARGET KF6::UserFeedbackWidgets)
    add_definitions(-DWITH_KUSERFEEDBACK)
endif()

add_subdirectory(pics)
add_subdirectory(icons)
add_subdirectory(kontactplugin)

########### kmailprivate ###############




set(kmail_debugcategory_SRCS)
ecm_qt_declare_logging_category(kmail_debugcategory_SRCS HEADER kmail_debug.h IDENTIFIER KMAIL_LOG CATEGORY_NAME org.kde.pim.kmail
    DESCRIPTION "kmail (kmail)"
    OLD_CATEGORY_NAMES log_kmail
    EXPORT KMAIL
)

ecm_qt_declare_logging_category(kmail_debugcategory_SRCS HEADER kmail_undo_send_debug.h IDENTIFIER KMAIL_UNDO_SEND_LOG CATEGORY_NAME org.kde.pim.kmail.undo.send
    DESCRIPTION "kmail undo send (kmail)"
    OLD_CATEGORY_NAMES log_undo_send_kmail
    EXPORT KMAIL
)

ecm_qt_declare_logging_category(kmail_debugcategory_SRCS HEADER kmail_activities_debug.h IDENTIFIER KMAIL_ACTIVITIES_LOG CATEGORY_NAME org.kde.pim.kmail.activities
    DESCRIPTION "kmail activities (kmail)"
    EXPORT KMAIL
)


add_library(kmailprivate)
if(TARGET KF6::UserFeedbackWidgets)
    target_sources(kmailprivate PRIVATE
        userfeedback/accountinfosource.cpp
        userfeedback/accountinfosource.h
        userfeedback/plugininfosource.cpp
        userfeedback/plugininfosource.h
        userfeedback/kmailuserfeedbackprovider.cpp
        userfeedback/kmailuserfeedbackprovider.h
)
endif()

target_sources(kmailprivate PRIVATE
    ${kmail_debugcategory_SRCS}
    attributes/taskattribute.cpp
    folderarchive/folderarchiveaccountinfo.cpp
    folderarchive/folderarchiveutil.cpp
    folderarchive/folderarchivecache.cpp
    folderarchive/folderarchiveagentcheckcollection.cpp
    folderarchive/folderarchivemanager.cpp
    folderarchive/folderarchiveagentjob.cpp
    collectionpage/collectiontemplatespage.cpp
    collectionpage/collectionviewpage.cpp
    collectionpage/collectionquotapage.cpp
    collectionpage/collectionquotawidget.cpp
    collectionpage/collectionmailinglistpage.cpp
    collectionpage/collectionshortcutpage.cpp
    configuredialog/configagentdelegate.cpp
    configuredialog/configuredialoglistview.cpp
    configuredialog/configuredialog.cpp
    configuredialog/configuredialog_p.cpp
    configuredialog/configuremiscpage.cpp
    configuredialog/configuresecuritypage.cpp
    configuredialog/configurecomposerpage.cpp
    configuredialog/configureappearancepage.cpp
    configuredialog/configureaccountpage.cpp
    configuredialog/configurepluginpage.cpp
    configuredialog/colorlistbox.cpp
    configuredialog/configureplugins/configurepluginslistwidget.cpp
    searchdialog/kmsearchmessagemodel.cpp
    searchdialog/searchpatternwarning.cpp
    searchdialog/kmailsearchpatternedit.cpp
    searchdialog/searchwindow.cpp
    searchdialog/searchdescriptionattribute.cpp
    searchdialog/incompleteindexdialog.cpp
    identity/identitydialog.cpp
    identity/xfaceconfigurator.cpp
    identity/encodedimagepicker.cpp
    identity/newidentitydialog.cpp
    identity/identityeditvcarddialog.cpp
    identity/identityaddvcarddialog.cpp
    identity/identityinvalidfolder.cpp
    identity/identityfolderrequester.cpp

    identity/identitytreengwidget.h
    identity/identitytreengwidget.cpp
    identity/identityngpage.cpp
    identity/identityngpage.h

    editor/kmcomposereditorng.cpp
    editor/encryptionstate.cpp
    editor/subjectlineeditwithautocorrection.cpp
    editor/subjectlineeditwithautocorrection.h
    editor/composer.cpp
    editor/kmcomposerwin.cpp
    editor/attachment/attachmentcontroller.cpp
    editor/attachment/attachmentview.cpp
    editor/widgets/cryptostateindicatorwidget.cpp
    editor/validatesendmailshortcut.cpp
    editor/kmcomposerglobalaction.cpp
    editor/kmcomposerupdatetemplatejob.cpp
    editor/kmcomposercreatenewcomposerjob.cpp
    editor/pimmessagebox.cpp
    editor/warningwidgets/externaleditorwarning.cpp
    editor/warningwidgets/attachmentmissingwarning.cpp
    editor/warningwidgets/incorrectidentityfolderwarning.cpp
    editor/warningwidgets/attachmentaddedfromexternalwarning.cpp
    editor/warningwidgets/toomanyrecipientswarning.cpp
    editor/warningwidgets/nearexpirywarning.cpp
    editor/potentialphishingemail/potentialphishingemailwarning.cpp
    editor/potentialphishingemail/potentialphishingemailjob.cpp
    editor/potentialphishingemail/potentialphishingdetaildialog.cpp
    editor/potentialphishingemail/potentialphishingdetailwidget.cpp
    dialog/archivefolderdialog.cpp
    dialog/addemailtoexistingcontactdialog.cpp
    dialog/kmknotify.cpp
    dialog/spellcheckerconfigdialog.cpp
    job/addressvalidationjob.cpp
    job/createnewcontactjob.cpp
    job/addemailtoexistingcontactjob.cpp
    job/createtaskjob.cpp
    job/savedraftjob.cpp
    job/removeduplicatemailjob.cpp
    job/createfollowupreminderonexistingmessagejob.cpp
    job/removecollectionjob.cpp
    job/saveasfilejob.cpp
    job/markallmessagesasreadinfolderandsubfolderjob.cpp
    job/removeduplicatemessageinfolderandsubfolderjob.cpp
    job/handleclickedurljob.cpp
    job/composenewmessagejob.cpp
    job/opencomposerjob.cpp
    job/newmessagejob.cpp
    job/opencomposerhiddenjob.cpp
    job/fillcomposerjob.cpp
    job/createreplymessagejob.cpp
    job/createforwardmessagejob.cpp
    job/dndfromarkjob.cpp
    job/clearcachejobinfolderandsubfolderjob.cpp
    job/clearcachejobinfolderandsubfolderjob.h
    widgets/collectionpane.cpp
    widgets/vacationscriptindicatorwidget.cpp
    widgets/displaymessageformatactionmenu.cpp
    widgets/kactionmenutransport.cpp
    widgets/kactionmenuaccount.cpp
    widgets/zoomlabelwidget.cpp
    tag/tagactionmanager.cpp
    tag/tagselectdialog.cpp
    tag/tagmonitormanager.cpp
    plugininterface/kmailplugininterface.cpp
    plugininterface/kmailplugincheckbeforedeletingmanagerinterface.cpp
    editor/plugininterface/kmailplugineditormanagerinterface.cpp
    editor/plugininterface/kmailplugineditorcheckbeforesendmanagerinterface.cpp
    editor/plugininterface/kmailplugineditorinitmanagerinterface.cpp
    editor/plugininterface/kmailplugineditorconverttextmanagerinterface.cpp
    editor/plugininterface/kmailplugingrammareditormanagerinterface.cpp

    sieveimapinterface/kmailsieveimapinstanceinterface.cpp
    sieveimapinterface/kmsieveimappasswordprovider.cpp
    undosend/undosendcombobox.cpp
    undosend/undosendmanager.cpp
    undosend/undosendcreatejob.cpp
    kmmainwin.cpp
    settings/kmailsettings.cpp
    kmreaderwin.cpp
    kmsystemtray.cpp
    unityservicemanager.cpp
    undostack.cpp
    kmkernel.cpp
    commandlineinfo.h
    commandlineinfo.cpp
    kmcommands.cpp
    kmreadermainwin.cpp
    kmmainwidget.cpp
    aboutdata.cpp
    mailserviceimpl.cpp
    secondarywindow.cpp
    util.cpp
    kmail_options.h
    messageactions.cpp
    foldershortcutactionmanager.cpp
    kmlaunchexternalcomponent.cpp
    manageshowcollectionproperties.cpp
    kmail.qrc

    attributes/taskattribute.h
    folderarchive/folderarchiveaccountinfo.h
    folderarchive/folderarchiveutil.h
    folderarchive/folderarchivecache.h
    folderarchive/folderarchiveagentcheckcollection.h
    folderarchive/folderarchivemanager.h
    folderarchive/folderarchiveagentjob.h
    collectionpage/collectiontemplatespage.h
    collectionpage/collectionviewpage.h
    collectionpage/collectionquotapage.h
    collectionpage/collectionquotawidget.h
    collectionpage/collectionmailinglistpage.h
    collectionpage/collectionshortcutpage.h
    configuredialog/configagentdelegate.h
    configuredialog/configuredialoglistview.h
    configuredialog/configuredialog.h
    configuredialog/configuredialog_p.h
    configuredialog/configuremiscpage.h
    configuredialog/configuresecuritypage.h
    configuredialog/configurecomposerpage.h
    configuredialog/configureappearancepage.h
    configuredialog/configureaccountpage.h
    configuredialog/configurepluginpage.h
    configuredialog/colorlistbox.h
    configuredialog/configureplugins/configurepluginslistwidget.h
    searchdialog/kmsearchmessagemodel.h
    searchdialog/searchpatternwarning.h
    searchdialog/kmailsearchpatternedit.h
    searchdialog/searchwindow.h
    searchdialog/searchdescriptionattribute.h
    searchdialog/incompleteindexdialog.h
    identity/identitydialog.h
    identity/xfaceconfigurator.h
    identity/encodedimagepicker.h
    identity/newidentitydialog.h
    identity/identityeditvcarddialog.h
    identity/identityaddvcarddialog.h
    identity/identityinvalidfolder.h
    identity/identityfolderrequester.h

    editor/kmcomposereditorng.h
    editor/composer.h
    editor/encryptionstate.h
    editor/kmcomposerwin.h
    editor/attachment/attachmentcontroller.h
    editor/attachment/attachmentview.h
    editor/widgets/cryptostateindicatorwidget.h
    editor/validatesendmailshortcut.h
    editor/kmcomposerglobalaction.h
    editor/kmcomposerupdatetemplatejob.h
    editor/kmcomposercreatenewcomposerjob.h
    editor/pimmessagebox.h
    editor/warningwidgets/externaleditorwarning.h
    editor/warningwidgets/attachmentmissingwarning.h
    editor/warningwidgets/incorrectidentityfolderwarning.h
    editor/warningwidgets/attachmentaddedfromexternalwarning.h
    editor/warningwidgets/toomanyrecipientswarning.h
    editor/warningwidgets/nearexpirywarning.h
    editor/potentialphishingemail/potentialphishingemailwarning.h
    editor/potentialphishingemail/potentialphishingemailjob.h
    editor/potentialphishingemail/potentialphishingdetaildialog.h
    editor/potentialphishingemail/potentialphishingdetailwidget.h
    dialog/archivefolderdialog.h
    dialog/addemailtoexistingcontactdialog.h
    dialog/kmknotify.h
    dialog/spellcheckerconfigdialog.h
    job/addressvalidationjob.h
    job/createnewcontactjob.h
    job/addemailtoexistingcontactjob.h
    job/createtaskjob.h
    job/savedraftjob.h
    job/removeduplicatemailjob.h
    job/createfollowupreminderonexistingmessagejob.h
    job/removecollectionjob.h
    job/saveasfilejob.h
    job/markallmessagesasreadinfolderandsubfolderjob.h
    job/removeduplicatemessageinfolderandsubfolderjob.h
    job/handleclickedurljob.h
    job/composenewmessagejob.h
    job/opencomposerjob.h
    job/newmessagejob.h
    job/opencomposerhiddenjob.h
    job/fillcomposerjob.h
    job/createreplymessagejob.h
    job/createforwardmessagejob.h
    job/dndfromarkjob.h
    widgets/collectionpane.h
    widgets/vacationscriptindicatorwidget.h
    widgets/displaymessageformatactionmenu.h
    widgets/kactionmenutransport.h
    widgets/kactionmenuaccount.h
    widgets/zoomlabelwidget.h
    tag/tagactionmanager.h
    tag/tagselectdialog.h
    tag/tagmonitormanager.h
    plugininterface/kmailplugininterface.h
    plugininterface/kmailplugincheckbeforedeletingmanagerinterface.h
    editor/plugininterface/kmailplugineditormanagerinterface.h
    editor/plugininterface/kmailplugineditorcheckbeforesendmanagerinterface.h
    editor/plugininterface/kmailplugineditorinitmanagerinterface.h
    editor/plugininterface/kmailplugineditorconverttextmanagerinterface.h
    editor/plugininterface/kmailplugingrammareditormanagerinterface.h

    sieveimapinterface/kmailsieveimapinstanceinterface.h
    sieveimapinterface/kmsieveimappasswordprovider.h
    undosend/undosendcombobox.h
    undosend/undosendmanager.h
    undosend/undosendcreatejob.h
    kmmainwin.h
    settings/kmailsettings.h
    kmreaderwin.h
    kmsystemtray.h
    unityservicemanager.h
    undostack.h
    kmkernel.h
    kmcommands.h
    kmreadermainwin.h
    kmmainwidget.h
    aboutdata.h
    mailserviceimpl.h

=== agents/archivemailagent/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2012-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause
add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_archivemail_agent\")

add_library(archivemailagent STATIC)
set_property(TARGET archivemailagent PROPERTY POSITION_INDEPENDENT_CODE ON)
target_sources(archivemailagent PRIVATE
    archivemailkernel.cpp
    archivemailmanager.cpp
    archivemailinfo.cpp
    job/archivejob.cpp
    archivemailagentutil.cpp
    archivemailkernel.h
    archivemailmanager.h
    archivemailinfo.h
    job/archivejob.h
    archivemailagentutil.h
)

kconfig_add_kcfg_files(archivemailagent
    settings/archivemailagentsettings.kcfgc
)


qt_add_dbus_adaptor(libarchivemailagent_SRCS org.freedesktop.Akonadi.ArchiveMailAgent.xml archivemailagent.h ArchiveMailAgent)
target_sources(archivemailagent PRIVATE ${libarchivemailagent_SRCS})

ecm_qt_declare_logging_category(archivemailagent HEADER archivemailagent_debug.h IDENTIFIER ARCHIVEMAILAGENT_LOG CATEGORY_NAME org.kde.pim.archivemailagent
        DESCRIPTION "kmail (archivemailagent)"
        OLD_CATEGORY_NAMES log_archivemailagent
        EXPORT KMAIL
)


ki18n_wrap_ui(archivemailagent ui/archivemailwidget.ui)

pim_target_precompile_headers(archivemailagent PUBLIC ../../kmail_pch.h)
#if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
#    set_target_properties(archivemailagent PROPERTIES UNITY_BUILD ON)
#endif()
target_link_libraries(archivemailagent
    KPim6::MailCommon
    KPim6::AkonadiAgentBase
    KF6::I18n
    KF6::Notifications
    KF6::KIOWidgets
)

########################### Agent executable ################################

add_executable(akonadi_archivemail_agent archivemailagent.cpp archivemailagent.h)

target_link_libraries(akonadi_archivemail_agent
    archivemailagent
    KPim6::AkonadiCore
    KPim6::IdentityManagementCore
    KPim6::AkonadiMime
    KPim6::AkonadiAgentBase
    KF6::DBusAddons
    KF6::XmlGui
    KF6::KIOWidgets
    KF6::Notifications
    KPim6::MailCommon
    KF6::I18n
)

if(APPLE)
    set_target_properties(akonadi_archivemail_agent PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${kmail_SOURCE_DIR}/agents/Info.plist.template)
    set_target_properties(akonadi_archivemail_agent PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.Akonadi.archivemail")
    set_target_properties(akonadi_archivemail_agent PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDE Akonadi Email Archiver")
endif()

install(TARGETS akonadi_archivemail_agent ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES archivemailagent.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents")
install(FILES akonadi_archivemail_agent.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR})


if(BUILD_TESTING)
    add_subdirectory(autotests)
endif()

########## Configuration ##############


kcoreaddons_add_plugin(archivemailagentconfig
    INSTALL_NAMESPACE pim6/akonadi/config
)
target_sources(archivemailagentconfig PRIVATE
    addarchivemaildialog.cpp
    addarchivemaildialog.h

    addarchivemailwidget.h
    addarchivemailwidget.cpp

    archivemailrangewidget.h
    archivemailrangewidget.cpp

    widgets/hourcombobox.h
    widgets/hourcombobox.cpp

    archivemailwidget.cpp
    archivemailwidget.h

    widgets/formatcombobox.cpp
    widgets/formatcombobox.h

    widgets/unitcombobox.cpp
    widgets/unitcombobox.h
)
target_link_libraries(archivemailagentconfig
    archivemailagent
    KPim6::AkonadiCore
    KF6::XmlGui
    KF6::I18n
)
#if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
#    set_target_properties(archivemailagentconfig PROPERTIES UNITY_BUILD ON)
#endif()


install(FILES settings/archivemailagentsettings.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

=== agents/followupreminderagent/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2014-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause
add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_followupreminder_agent\")

add_library(followupreminderagent STATIC)
set_property(TARGET followupreminderagent PROPERTY POSITION_INDEPENDENT_CODE ON)



kconfig_add_kcfg_files(followupreminderagent
        followupreminderagentsettings.kcfgc
)

ecm_qt_declare_logging_category(followupreminderagent HEADER followupreminderagent_debug.h IDENTIFIER FOLLOWUPREMINDERAGENT_LOG CATEGORY_NAME org.kde.pim.followupreminderagent
        DESCRIPTION "kmail (followupreminderagent)"
        OLD_CATEGORY_NAMES log_followupreminderagent
        EXPORT KMAIL
)

qt_add_dbus_adaptor(followupreminderagent_SRCS org.freedesktop.Akonadi.FollowUpReminder.xml followupreminderagent.h FollowUpReminderAgent)

qt_add_dbus_interface(followupreminderagent_SRCS org.freedesktop.Notifications.xml notifications_interface)
qt_add_dbus_interface(followupreminderagent_SRCS org.freedesktop.DBus.Properties.xml dbusproperties)

target_sources(followupreminderagent PRIVATE
    followupremindermanager.cpp
    followupremindernoanswerdialog.cpp
    followupreminderinfowidget.cpp
    followupreminderinfo.cpp
    followupreminderutil.cpp
    jobs/followupreminderjob.cpp
    jobs/followupreminderfinishtaskjob.cpp
    jobs/followupremindershowmessagejob.cpp

    followupremindermanager.h
    followupremindernoanswerdialog.h
    followupreminderinfowidget.h
    followupreminderinfo.h
    followupreminderutil.h
    jobs/followupreminderjob.h
    jobs/followupreminderfinishtaskjob.h
    jobs/followupremindershowmessagejob.h

    ${followupreminderagent_SRCS}
)

pim_target_precompile_headers(followupreminderagent PUBLIC ../../kmail_pch.h)
#if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
#    set_target_properties(followupreminderagent PROPERTIES UNITY_BUILD ON)
#endif()

target_link_libraries(followupreminderagent
    KPim6::AkonadiCore
    KPim6::IdentityManagementCore
    KPim6::AkonadiMime
    KPim6::AkonadiAgentBase
    KF6::DBusAddons
    KF6::XmlGui
    KF6::KIOWidgets
    KF6::Notifications
    KPim6::MailCommon
    KF6::I18n
    KF6::CalendarCore
)


########################### Agent executable ################################
add_executable(akonadi_followupreminder_agent followupreminderagent.cpp followupreminderagent.h)

target_link_libraries(akonadi_followupreminder_agent
    followupreminderagent
    KPim6::AkonadiCore
    KPim6::AkonadiMime
    KPim6::AkonadiAgentBase
    KPim6::Mime
    KF6::CalendarCore
    KF6::DBusAddons
    Qt::Widgets
    KF6::Notifications
    KF6::I18n
    KF6::XmlGui
    KF6::Service
)

if(APPLE)
    set_target_properties(akonadi_followupreminder_agent PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${kmail_SOURCE_DIR}/agents/Info.plist.template)
    set_target_properties(akonadi_followupreminder_agent PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.akonadi_followupreminder_agent")
    set_target_properties(akonadi_followupreminder_agent PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDE Akonadi Followup Reminder Agent")
endif()

install(TARGETS akonadi_followupreminder_agent ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES followupreminder.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents")

if(BUILD_TESTING)
    add_subdirectory(autotests)
endif()

install(FILES akonadi_followupreminder_agent.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR})

########## Configuration ##############

set(followupreminderagentconfig_SRCS
    followupreminderinfoconfigwidget.cpp
    followupreminderinfoconfigwidget.h
)

kcoreaddons_add_plugin(followupreminderagentconfig
    SOURCES ${followupreminderagentconfig_SRCS}
    INSTALL_NAMESPACE pim6/akonadi/config
)
target_link_libraries(followupreminderagentconfig
    followupreminderagent
    KPim6::AkonadiCore
    KF6::XmlGui
    KF6::I18n
)

=== agents/mailfilteragent/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause

add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_mailfilter_agent\")

add_library(mailfilteragentprivate)


target_sources(mailfilteragentprivate PRIVATE
    filterlogdialog.cpp
    filterlogdialog.h
    mailfilterpurposemenuwidget.cpp
    mailfilterpurposemenuwidget.h

    mailfilteragent_private_export.h
)

if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(mailfilteragentprivate PROPERTIES UNITY_BUILD ON)
endif()

generate_export_header(mailfilteragentprivate BASE_NAME mailfilteragentprivate)
target_link_libraries(mailfilteragentprivate
    KF6::I18n
    Qt::Widgets
    KF6::TextCustomEditor
    KPim6::PimCommon
    KPim6::MailCommon
)

set_target_properties(mailfilteragentprivate
    PROPERTIES OUTPUT_NAME mailfilteragentprivate VERSION ${KDEPIM_LIB_VERSION} SOVERSION ${KDEPIM_LIB_SOVERSION}
)
install(TARGETS mailfilteragentprivate ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} LIBRARY NAMELINK_SKIP)


add_executable(akonadi_mailfilter_agent)
set(dbusobjectmanager_xml org.freedesktop.Akonadi.MailFilterAgent.xml)
set_source_files_properties(${dbusobjectmanager_xml} PROPERTIES INCLUDE "dbusoperators.h")
qt_add_dbus_adaptor(akonadi_mailfilter_agent_SRCS ${dbusobjectmanager_xml} mailfilteragent.h MailFilterAgent)

target_sources(akonadi_mailfilter_agent PRIVATE
    dummykernel.cpp
    filtermanager.cpp
    mailfilteragent.cpp
    dummykernel.h
    filtermanager.h
    mailfilteragent.h
    ${akonadi_mailfilter_agent_SRCS}
)



ecm_qt_declare_logging_category(akonadi_mailfilter_agent HEADER mailfilteragent_debug.h IDENTIFIER MAILFILTERAGENT_LOG CATEGORY_NAME org.kde.pim.mailfilteragent
        DESCRIPTION "kmail (mailfilter agent)"
        OLD_CATEGORY_NAMES log_mailfilteragent
        EXPORT KMAIL
)


if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(akonadi_mailfilter_agent PROPERTIES UNITY_BUILD ON)
endif()

if(APPLE)
    set_target_properties(akonadi_mailfilter_agent PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${kmail_SOURCE_DIR}/agents/Info.plist.template)
    set_target_properties(akonadi_mailfilter_agent PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.Akonadi.mailfilter")
    set_target_properties(akonadi_mailfilter_agent PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDE Akonadi Email Filter")
endif()


target_link_libraries(akonadi_mailfilter_agent
    KPim6::MailCommon
    KPim6::MessageComposer
    KPim6::PimCommon
    KPim6::AkonadiCore
    KPim6::AkonadiMime
    KPim6::AkonadiAgentBase
    KPim6::Mime
    KPim6::IdentityManagementCore
    KF6::DBusAddons
    KF6::Notifications
    KF6::WindowSystem
    KF6::I18n
    mailfilteragentprivate
)

install(TARGETS akonadi_mailfilter_agent ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES mailfilteragent.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents")
install(FILES akonadi_mailfilter_agent.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR})

add_subdirectory(tests)

=== agents/mailmergeagent/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2021-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause

add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_mailmerge_agent\")
if(BUILD_TESTING)
    add_subdirectory(tests)
    add_subdirectory(autotests)
endif()
add_library(mailmergeagent STATIC)
set_property(TARGET mailmergeagent PROPERTY POSITION_INDEPENDENT_CODE ON)


ecm_qt_declare_logging_category(mailmergeagent HEADER mailmergeagent_debug.h IDENTIFIER MAILMERGEAGENT_LOG CATEGORY_NAME org.kde.pim.mailmergeagent
        DESCRIPTION "kmail (mailmergeagent)"
        OLD_CATEGORY_NAMES log_mailmergeagent
        EXPORT KMAIL
)

qt_add_dbus_adaptor(mailmergeagent_SRCS org.freedesktop.Akonadi.MailMergeAgent.xml mailmergeagent.h MailMergeAgent)

ki18n_wrap_ui(mailmergeagent ui/mailmergeconfigurewidget.ui)

target_sources(mailmergeagent PRIVATE
    mailmergeagent.cpp
    mailmergemanager.cpp
    mailmergeconfiguredialog.cpp
    mailmergeconfigurewidget.cpp
    mailmergeutil.cpp
    mailmergeagent.h
    mailmergemanager.h
    mailmergeconfiguredialog.h
    mailmergeconfigurewidget.h
    mailmergeutil.h
    ${mailmergeagent_SRCS}
)

kconfig_add_kcfg_files(mailmergeagent mailmergeagentsettings.kcfgc)
#if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
#    set_target_properties(sendlateragent PROPERTIES UNITY_BUILD ON)
#endif()

target_link_libraries(mailmergeagent
    KPim6::AkonadiCore
    KPim6::AkonadiMime
    #KPim6::Mime
    KPim6::MessageComposer
    KPim6::MessageCore
    KF6::DBusAddons
    KF6::WindowSystem
    KF6::XmlGui
    KF6::I18n
    KF6::Notifications
    KPim6::AkonadiAgentBase
)

add_executable(akonadi_mailmerge_agent)
target_link_libraries(akonadi_mailmerge_agent
    mailmergeagent
    KPim6::AkonadiAgentBase
)



if(APPLE)
    set_target_properties(akonadi_mailmerge_agent PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${kmail_SOURCE_DIR}/agents/Info.plist.template)
    set_target_properties(akonadi_mailmerge_agent PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDE Akonadi Mail Merge")
endif()

install(TARGETS akonadi_mailmerge_agent ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES mailmergeagent.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents")
install(FILES akonadi_mailmerge_agent.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR})

#kcoreaddons_add_plugin(mailmergeagentconfig
#    SOURCES ${mailmergeagentconfig_SRCS}
#    INSTALL_NAMESPACE pim6/akonadi/config
#   )

=== agents/sendlateragent/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2013-2024 Laurent Montel <montel@kde.org>
# SPDX-License-Identifier: BSD-3-Clause
add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_sendlater_agent\")

if(BUILD_TESTING)
    add_subdirectory(tests)
    add_subdirectory(autotests)
endif()

set(sendlater_common_SRCS)
ecm_qt_declare_logging_category(sendlater_common_SRCS HEADER sendlateragent_debug.h IDENTIFIER SENDLATERAGENT_LOG CATEGORY_NAME org.kde.pim.sendlateragent
        DESCRIPTION "kmail (sendlateragent)"
        OLD_CATEGORY_NAMES log_sendlateragent
        EXPORT KMAIL
)


set(libsendlateragent_SRCS
    sendlaterconfiguredialog.cpp
    sendlaterconfigurewidget.cpp
    sendlatermanager.cpp
    sendlaterjob.cpp
    sendlaterremovemessagejob.cpp
    sendlaterutil.cpp
    sendlaterconfiguredialog.h
    sendlaterconfigurewidget.h
    sendlatermanager.h
    sendlaterjob.h
    sendlaterremovemessagejob.h
    sendlaterutil.h
    ${sendlater_common_SRCS}
)

set(sendlateragent_SRCS
    sendlateragent.cpp
    sendlateragent.h
)

qt_add_dbus_adaptor(sendlateragent_SRCS org.freedesktop.Akonadi.SendLaterAgent.xml sendlateragent.h SendLaterAgent)


ki18n_wrap_ui(libsendlateragent_SRCS ui/sendlaterconfigurewidget.ui)
kconfig_add_kcfg_files(libsendlateragent_SRCS sendlateragentsettings.kcfgc)
add_library(sendlateragent STATIC ${libsendlateragent_SRCS})
set_property(TARGET sendlateragent PROPERTY POSITION_INDEPENDENT_CODE ON)

pim_target_precompile_headers(sendlateragent PUBLIC ../../kmail_pch.h)
#if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
#    set_target_properties(sendlateragent PROPERTIES UNITY_BUILD ON)
#endif()

target_link_libraries(sendlateragent
    KPim6::AkonadiCore
    KPim6::AkonadiMime
    KPim6::MailTransport
    KPim6::Mime
    KPim6::MessageComposer
    KPim6::MessageCore
    KPim6::PimCommon
    KF6::DBusAddons
    KF6::WindowSystem
    KF6::XmlGui
    KF6::Notifications
    KF6::I18n
)


add_executable(akonadi_sendlater_agent ${sendlateragent_SRCS})
target_link_libraries(akonadi_sendlater_agent
    sendlateragent
    KPim6::AkonadiAgentBase
)

if(APPLE)
    set_target_properties(akonadi_sendlater_agent PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${kmail_SOURCE_DIR}/agents/Info.plist.template)
    set_target_properties(akonadi_sendlater_agent PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDE Akonadi Send Later")
endif()

install(TARGETS akonadi_sendlater_agent ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES sendlateragent.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents")
install(FILES akonadi_sendlater_agent.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR})

#kcoreaddons_add_plugin(sendlateragentconfig
#    SOURCES ${sendlateragentconfig_SRCS}
#    INSTALL_NAMESPACE pim6/akonadi/config
#)

=== agents/unifiedmailboxagent/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
add_definitions(-DTRANSLATION_DOMAIN=\"akonadi_unifiedmailbox_agent\")

if(BUILD_TESTING)
    add_subdirectory(autotests)
endif()


add_executable(akonadi_unifiedmailbox_agent)
ecm_qt_declare_logging_category(akonadi_unifiedmailbox_agent HEADER unifiedmailboxagent_debug.h IDENTIFIER UNIFIEDMAILBOXAGENT_LOG CATEGORY_NAME org.kde.pim.unifiedmailboxagent
        DESCRIPTION "kmail (unifiedmailboxagent)"
        EXPORT KMAIL
)

kconfig_add_kcfg_files(akonadi_unifiedmailbox_agent
    settings.kcfgc
)

qt_add_dbus_adaptor(unifiedmailbox_agent_SRCS org.freedesktop.Akonadi.UnifiedMailboxAgent.xml unifiedmailboxagent.h UnifiedMailboxAgent)
target_sources(akonadi_unifiedmailbox_agent PRIVATE
    unifiedmailbox.cpp
    unifiedmailboxagent.cpp
    unifiedmailboxmanager.cpp
    unifiedmailboxeditor.cpp
    settingsdialog.cpp
    mailkernel.cpp
    unifiedmailbox.h
    unifiedmailboxagent.h
    unifiedmailboxmanager.h
    unifiedmailboxeditor.h
    settingsdialog.h
    mailkernel.h
    ${unifiedmailbox_agent_SRCS}
)

#if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
#    set_target_properties(akonadi_unifiedmailbox_agent PROPERTIES UNITY_BUILD ON)
#endif()
target_link_libraries(akonadi_unifiedmailbox_agent
    KPim6::AkonadiAgentBase
    KPim6::AkonadiMime
    KPim6::AkonadiWidgets
    KPim6::Mime
    KF6::I18n
    KPim6::IdentityManagementCore
    KF6::WidgetsAddons
    KF6::IconThemes
    KF6::IconWidgets
    KF6::ItemModels
    KPim6::MailCommon
    KF6::DBusAddons
)

if(APPLE)
    set_target_properties(akonadi_unifiedmailbox_agent PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${kmail_SOURCE_DIR}/agents/Info.plist.template)
    set_target_properties(akonadi_unifiedmailbox_agent PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.Akonadi.KF6::UnifiedMailbox")
    set_target_properties(akonadi_unifiedmailbox_agent PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDE PIM Unified Mailbox")
endif()

install(TARGETS akonadi_unifiedmailbox_agent ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES unifiedmailboxagent.desktop DESTINATION "${KDE_INSTALL_DATAROOTDIR}/akonadi/agents")

=== ktnef/src/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause

configure_file(ktnef-version.h.in ${CMAKE_CURRENT_BINARY_DIR}/ktnef-version.h @ONLY)

add_subdirectory(pics)
add_executable(ktnef)

target_sources(ktnef PRIVATE
    main.cpp
    attachpropertydialog.cpp
    ktnefmain.cpp
    ktnefview.cpp
    messagepropertydialog.cpp
    qwmf.cpp
    attachpropertydialog.h
    ktnefmain.h
    ktnefview.h
    messagepropertydialog.h
    qwmf.h
    ktnef.qrc
)

ecm_qt_declare_logging_category(ktnef HEADER ktnef_debug.h IDENTIFIER KTNEFAPPS_LOG CATEGORY_NAME org.kde.pim.ktnefapps
	DESCRIPTION "kmail (ktnef apps)"
        EXPORT KMAIL
)


file(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/pics/hicolor/*-apps-ktnef.png")
ecm_add_app_icon(ktnef ICONS ${ICONS_SRCS})

ki18n_wrap_ui(ktnef ui/attachpropertywidgetbase.ui)

if(COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(ktnef PROPERTIES UNITY_BUILD ON)
endif()

target_link_libraries(ktnef
    Qt::Widgets
    KPim6::Tnef
    KF6::DBusAddons
    KF6::Crash
    KF6::I18n
    KF6::XmlGui
    KF6::WidgetsAddons
    KF6::Service
    KF6::KIOWidgets
)


install(TARGETS ktnef ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(PROGRAMS org.kde.ktnef.desktop DESTINATION ${KDE_INSTALL_APPDIR})

=== src/avscripts/CMakeLists.txt ===
if(Q_WS_X11)
  install(PROGRAMS kmail_clamav.sh kmail_sav.sh kmail_fprot.sh kmail_antivir.sh  DESTINATION ${KDE_INSTALL_BINDIR})
endif()

=== debian/changelog ===
kmail (4:24.12.3-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (24.12.3).
  * Update build-deps and deps with the info from cmake.
  * Bump Standards-Version to 4.7.2 (No changes needed).

 -- Patrick Franz <deltaone@debian.org>  Sat, 29 Mar 2025 18:51:35 +0100

=== debian/control ===
Source: kmail
Section: kde
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Michael Meskes <meskes@debian.org>,
           Sandro Knauß <hefee@debian.org>,
           Sune Vuorela <sune@debian.org>,
           Patrick Franz <deltaone@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               cmake (>= 3.16~),
               extra-cmake-modules (>= 6.6.0~),
               gettext,
               libakonadi-dev (>= 4:24.12.3~),
               libakonadicontact-dev (>= 4:24.12.3~),
               libakonadimime-dev (>= 4:24.12.3~),
               libakonadisearch-dev (>= 4:24.12.3~),
               libgpg-error-dev (>= 1.36~),
               libgpgmepp-dev (>= 1.23.2~),
               libgravatar-dev (>= 4:24.12.3~),
               libkcalendarutils-dev (>= 4:24.12.3~),
               libkdepim-dev (>= 4:24.12.3~),
               libkf6bookmarks-dev (>= 6.6.0~),
               libkf6calendarcore-dev (>= 6.6.0~),
               libkf6config-dev (>= 6.6.0~),
               libkf6configwidgets-dev (>= 6.3.0~),
               libkf6contacts-dev (>= 6.6.0~),
               libkf6crash-dev (>= 6.6.0~),
               libkf6dbusaddons-dev (>= 6.6.0~),
               libkf6doctools-dev (>= 6.6.0~),
               libkf6guiaddons-dev (>= 6.6.0~),
               libkf6i18n-dev (>= 6.6.0~),
               libkf6iconthemes-dev (>= 6.6.0~),
               libkf6itemviews-dev (>= 6.6.0~),
               libkf6jobwidgets-dev (>= 6.6.0~),
               libkf6kcmutils-dev (>= 6.6.0~),
               libkf6kio-dev (>= 6.6.0~),
               libkf6notifications-dev (>= 6.6.0~),
               libkf6notifyconfig-dev (>= 6.6.0~),
               libkf6parts-dev (>= 6.6.0~),
               libkf6service-dev (>= 6.6.0~),
               libkf6sonnet-dev (>= 6.6.0~),
               libkf6statusnotifieritem-dev (>= 6.6.0~),
               libkf6textwidgets-dev (>= 6.3.0~),
               libkf6userfeedback-dev (>= 6.6.0~),
               libkf6widgetsaddons-dev (>= 6.6.0~),
               libkf6windowsystem-dev (>= 6.6.0~),
               libkf6xmlgui-dev (>= 6.6.0~),
               libkidentitymanagement-dev (>= 24.12.3~),
               libkldap-dev (>= 24.12.3~),
               libkleo-dev (>= 4:24.12.3~),
               libkmailtransport-dev (>= 24.12.3~),
               libkmime-dev (>= 24.12.3~),
               libkontactinterface-dev (>= 24.12.3~),
               libkpimtextedit-dev (>= 24.12.3~),
               libksieve-dev (>= 4:24.12.3~),
               libktextaddons-dev (>= 1.5.4~),
               libktnef-dev (>= 4:24.12.3~),
               libmailcommon-dev (>= 4:24.12.3~),
               libpimcommon-dev (>= 4:24.12.3~),
               libplasmaactivities-dev (>= 6.1.0~),
               messagelib-dev (>= 4:24.12.3~),
               pkgconf,
               qt6-base-dev (>= 6.7.0~),
               qt6-webengine-dev (>= 6.7.0~),
               qtkeychain-qt6-dev (>= 0.14.2~),
               xauth <!nocheck>,
               xvfb <!nocheck>,
Standards-Version: 4.7.2
Homepage: https://invent.kde.org/pim/kmail
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kmail
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kmail.git
Rules-Requires-Root: no

Package: kmail
Section: mail
Architecture: amd64 arm64 armhf i386
Pre-Depends: ${misc:Pre-Depends},
Depends: akonadi-server (>= 4:24.08~),
         kdepim-runtime (>= 4:24.08~),
         libakonadisearch-bin (>= 4:24.08~),
         libakonadisearch-plugins (>= 4:24.08~),
         libgrantleetheme-plugins (>= 24.08~),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: accountwizard,
            gnupg,
            kdepim-addons,
            kdepim-themeeditors,
            mbox-importer,
            pim-data-exporter,
            pim-sieve-editor,
            pinentry-qt | pinentry-x11,
Suggests: clamav,
          kaddressbook,
          kleopatra,
          procmail,
          spamassassin | bogofilter | spambayes (>= 1.0.4-6) | bsfilter | crm114,
Provides: imap-client, mail-reader,
Homepage: http://kontact.kde.org/kmail/
Description: full featured graphical email client
 KMail supports multiple accounts, mail filtering and email encryption.
 The program let you configure your workflow and it has good integration into
 KDE (Plasma Desktop) but is also useable with other Desktop Environments.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_test:
	- xvfb-run -- dh_auto_test --no-parallel
